commit 91ac88cada3960517415bc92ae6d2d13a5e779a0
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Wed Jan 19 00:42:18 2022

    c++: Fix handling of temporaries with consteval ctors and non-trivial dtors [PR104055]
    
    The following testcase is miscompiled.  We see the constructor is immediate,
    in build_over_call we trigger:
              if (obj_arg && is_dummy_object (obj_arg))
                {
                  call = build_cplus_new (DECL_CONTEXT (fndecl), call, complain);
                  obj_arg = NULL_TREE;
                }
    which makes call a TARGET_EXPR with the dtor in TARGET_EXPR_CLEANUP,
    but then call cxx_constant_value on it.  In cxx_eval_outermost_constant_expr
    it triggers the:
          else if (TREE_CODE (t) != CONSTRUCTOR)
            {
              r = get_target_expr_sfinae (r, tf_warning_or_error | tf_no_cleanup);
              TREE_CONSTANT (r) = true;
            }
    which wraps the CONSTRUCTOR r into a new TARGET_EXPR, but one without
    dtors (I think we need e.g. the TREE_CONSTANT for the callers),
    and finally build_over_call uses that.
    
    The following patch fixes that by using get_target_expr instead
    of get_target_expr_sfinae + TREE_CONSTANT (r) = true if t is
    a TARGET_EXPR with non-NULL TARGET_EXPR_CLEANUP.
    
    2022-01-19  Jakub Jelinek  <jakub@redhat.com>
    
            PR c++/104055
            * constexpr.c (cxx_eval_outermost_constant_expr): If t is a
            TARGET_EXPR with TARGET_EXPR_CLEANUP, use get_target_expr rather
            than get_target_expr_sfinae with tf_no_cleanup, and don't set
            TREE_CONSTANT.
    
            * g++.dg/cpp2a/consteval27.C: New test.
    
    (cherry picked from commit 1a5145f1e3adf8b2ba4ad416a5ddef59a1e34d48)

diff --git a/gcc/cp/constexpr.c b/gcc/cp/constexpr.c
index 4f1f454fe1c..57decc97455 100644
--- a/gcc/cp/constexpr.c
+++ b/gcc/cp/constexpr.c
@@ -7411,7 +7411,11 @@ cxx_eval_outermost_constant_expr (tree t, bool allow_non_constant,
       if (TREE_CODE (t) == TARGET_EXPR
 	  && TARGET_EXPR_INITIAL (t) == r)
 	return t;
-      else if (TREE_CODE (t) != CONSTRUCTOR)
+      else if (TREE_CODE (t) == CONSTRUCTOR)
+	;
+      else if (TREE_CODE (t) == TARGET_EXPR && TARGET_EXPR_CLEANUP (t))
+	r = get_target_expr (r);
+      else
 	{
 	  r = get_target_expr_sfinae (r, tf_warning_or_error | tf_no_cleanup);
 	  TREE_CONSTANT (r) = true;
diff --git a/gcc/testsuite/g++.dg/cpp2a/consteval27.C b/gcc/testsuite/g++.dg/cpp2a/consteval27.C
new file mode 100644
index 00000000000..72d56df9dc5
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp2a/consteval27.C
@@ -0,0 +1,18 @@
+// PR c++/104055
+// { dg-do run { target c++20 } }
+
+int g;
+
+struct A { 
+  ~A () { if (a != 17 || b != 26) __builtin_abort (); g = 42; }
+  consteval A () : a (17), b (26) {}
+  int a, b;
+};
+
+int
+main ()
+{
+  A{};
+  if (g != 42)
+    __builtin_abort ();
+}

